diff -Naur nagios-2.0b3/base/Makefile.in nagios-2.0b3-test/base/Makefile.in
--- nagios-2.0b3/base/Makefile.in	2004-12-09 07:48:33.000000000 +0100
+++ nagios-2.0b3-test/base/Makefile.in	2005-05-31 19:29:22.726097000 +0200
@@ -11,7 +11,7 @@
 SRC_XDATA=../xdata
 
 CC=@CC@
-CFLAGS=@CFLAGS@ @DEFS@ -DNSCORE
+CFLAGS=@CFLAGS@ @DEFS@ -DNSCORE -DUSE_XSDNG -DUSE_XODNG
 
 # Compiler flags for optimization (overrides default)
 #CFLAGS=-O3 -Wall -Wshadow -Wpointer-arith -Wcast-qual -Wcast-align -Wstrict-prototypes -Wmissing-prototypes -Wnested-externs -DHAVE_CONFIG_H -DNSCORE
@@ -64,6 +64,11 @@
 XDDC=@XDDC@
 XDDH=@XDDH@
 
+XSDNGC=xsdng.c
+XODNGC=xodng.c
+XNGUTILSC=xngutils.c
+XNGH=xng.h
+
 # Extra base code
 BASEEXTRALIBS=@BASEEXTRALIBS@
 
@@ -75,7 +80,7 @@
 # Object data
 #ODATALIBS=$(SRC_COMMON)/objects.c $(SRC_XDATA)/$(XODC)
 #ODATAHDRS=$(SRC_INCLUDE)/objects.h $(SRC_XDATA)/$(XODH)
-ODATALIBS=objects-base.o xobjects-base.o
+ODATALIBS=objects-base.o xobjects-base.o xobjects-ng-base.o
 ODATAHDRS=
 ODATADEPS=$(ODATALIBS)
 
@@ -96,7 +101,7 @@
 # Status data
 #SDATALIBS=$(SRC_COMMON)/statusdata.c $(SRC_XDATA)/$(XSDC)
 #SDATAHDRS=$(SRC_INCLUDE)/statusdata.h $(SRC_XDATA)/$(XSDH)
-SDATALIBS=statusdata-base.o xstatusdata-base.o
+SDATALIBS=statusdata-base.o xstatusdata-base.o xstatusdata-ng-base.o
 SDATAHDRS=
 SDATADEPS=$(SDATALIBS)
 
@@ -115,7 +120,7 @@
 DDATADEPS=$(DDATALIBS)
 
 
-OBJS=$(BROKER_O) checks.o config.o commands.o events.o flapping.o logging.o notifications.o sehandlers.o utils.o $(RDATALIBS) $(CDATALIBS) $(ODATALIBS) $(SDATALIBS) $(PDATALIBS) $(DDATALIBS) $(BASEEXTRALIBS) $(SNPRINTF_O) $(PERLXSI_O)
+OBJS=$(BROKER_O) checks.o config.o commands.o events.o flapping.o logging.o notifications.o sehandlers.o utils.o xngutils-base.o $(RDATALIBS) $(CDATALIBS) $(ODATALIBS) $(SDATALIBS) $(PDATALIBS) $(DDATALIBS) $(BASEEXTRALIBS) $(SNPRINTF_O) $(PERLXSI_O)
 OBJDEPS=$(ODATADEPS) $(ODATADEPS) $(RDATADEPS) $(CDATADEPS) $(SDATADEPS) $(PDATADEPS) $(DDATADEPS) $(BROKER_H)
 
 all: nagios nagiostats
@@ -129,12 +134,21 @@
 xobjects-base.o: $(SRC_XDATA)/$(XODC) $(SRC_XDATA)/$(XODH)
 	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XODC)
 
+xobjects-ng-base.o: $(SRC_XDATA)/$(XODNGC) $(SRC_XDATA)/$(XNGH)
+	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XODNGC)
+
 statusdata-base.o: $(SRC_COMMON)/statusdata.c $(SRC_INCLUDE)/statusdata.h
 	$(CC) $(CFLAGS) -c -o $@ $(SRC_COMMON)/statusdata.c
 
 xstatusdata-base.o: $(SRC_XDATA)/$(XSDC) $(SRC_XDATA)/$(XSDH)
 	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XSDC)
 
+xstatusdata-ng-base.o: $(SRC_XDATA)/$(XSDNGC) $(SRC_XDATA)/$(XNGH)
+	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XSDNGC)
+
+xngutils-base.o: $(SRC_XDATA)/$(XNGUTILSC) $(SRC_XDATA)/$(XNGH)
+	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XNGUTILSC)
+
 comments-base.o: $(SRC_COMMON)/comments.c $(SRC_INCLUDE)/comments.h
 	$(CC) $(CFLAGS) -c -o $@ $(SRC_COMMON)/comments.c
 
diff -Naur nagios-2.0b3/cgi/Makefile.in nagios-2.0b3-test/cgi/Makefile.in
--- nagios-2.0b3/cgi/Makefile.in	2004-10-25 07:05:54.000000000 +0200
+++ nagios-2.0b3-test/cgi/Makefile.in	2005-06-03 17:58:03.152944000 +0200
@@ -4,6 +4,7 @@
 # Last Modified: 10-24-2004
 ###############################
 
+#PURIFY=purify --cache-dir=/var/tmp/purify
 
 # Source code directories
 SRC_COMMON=../common
@@ -26,7 +27,7 @@
 
 CP=@CP@
 CC=@CC@
-CFLAGS=@CFLAGS@ @DEFS@ -DNSCGI
+CFLAGS=@CFLAGS@ @DEFS@ -DNSCGI -DUSE_XSDNG -DUSE_XODNG
 
 # Compiler flags for optimization (overrides default)
 #CFLAGS=-O3 -Wall -Wshadow -Wpointer-arith -Wcast-qual -Wcast-align -Wstrict-prototypes -Wmissing-prototypes -Wnested-externs -DHAVE_CONFIG_H -DNSCGI
@@ -51,20 +52,25 @@
 XDDC=@XDDC@
 XDDH=@XDDH@
 
+XSDNGC=xsdng.c
+XODNGC=xodng.c
+XNGUTILSC=xngutils.c
+XNGH=xng.h
+
 # Generated automatically from configure script
 SNPRINTF_O=@SNPRINTF_O@
 
 # Object functions
 #ODATALIBS=$(SRC_COMMON)/objects.c $(SRC_XDATA)/$(XODC)
 #ODATAHDRS=$(SRC_INCLUDE)/objects.h $(SRC_XDATA)/$(XODH)
-ODATALIBS=objects-cgi.o xobjects-cgi.o
+ODATALIBS=objects-cgi.o xobjects-cgi.o xobjects-ng-cgi.o
 ODATAHDRS=
 ODATADEPS=$(ODATALIBS)
 
 # Host, service, and program status functions
 #SDATALIBS=$(SRC_COMMON)/statusdata.c $(SRC_XDATA)/$(XSDC)
 #SDATAHDRS=$(SRC_INCLUDE)/statusdata.h $(SRC_XDATA)/$(XSDH)
-SDATALIBS=statusdata-cgi.o xstatusdata-cgi.o
+SDATALIBS=statusdata-cgi.o xstatusdata-cgi.o xstatusdata-ng-cgi.o
 SDATAHDRS=
 SDATADEPS=$(SDATALIBS)
 
@@ -83,7 +89,7 @@
 DDATADEPS=$(DDATALIBS)
 
 # Common CGI functions (includes object and status functions)
-CGILIBS=getcgi.o cgiutils.o cgiauth.o $(SNPRINTF_O) $(ODATALIBS) $(SDATALIBS)
+CGILIBS=getcgi.o cgiutils.o cgiauth.o xngutils-cgi.o $(SNPRINTF_O) $(ODATALIBS) $(SDATALIBS)
 CGIHDRS=$(SRC_INCLUDE)/config.h $(SRC_INCLUDE)/common.h $(SRC_INCLUDE)/locations.h
 CGIDEPS=$(CGILIBS) $(ODATADEPS) $(SDATADEPS)
 
@@ -105,12 +111,21 @@
 xobjects-cgi.o: $(SRC_XDATA)/$(XODC) $(SRC_XDATA)/$(XODH)
 	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XODC)
 
+xobjects-ng-cgi.o: $(SRC_XDATA)/$(XODNGC) $(SRC_XDATA)/$(XNGH)
+	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XODNGC)
+
 statusdata-cgi.o: $(SRC_COMMON)/statusdata.c $(SRC_INCLUDE)/statusdata.h
 	$(CC) $(CFLAGS) -c -o $@ $(SRC_COMMON)/statusdata.c
 
 xstatusdata-cgi.o: $(SRC_XDATA)/$(XSDC) $(SRC_XDATA)/$(XSDH)
 	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XSDC)
 
+xstatusdata-ng-cgi.o: $(SRC_XDATA)/$(XSDNGC) $(SRC_XDATA)/$(XNGH)
+	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XSDNGC)
+
+xngutils-cgi.o: $(SRC_XDATA)/$(XNGUTILSC) $(SRC_XDATA)/$(XNGH)
+	$(CC) $(CFLAGS) -c -o $@ $(SRC_XDATA)/$(XNGUTILSC)
+
 comments-cgi.o: $(SRC_COMMON)/comments.c $(SRC_INCLUDE)/comments.h
 	$(CC) $(CFLAGS) -c -o $@ $(SRC_COMMON)/comments.c
 
diff -Naur nagios-2.0b3/cgi/status.c nagios-2.0b3-test/cgi/status.c
--- nagios-2.0b3/cgi/status.c	2005-03-11 02:16:35.000000000 +0100
+++ nagios-2.0b3-test/cgi/status.c	2005-06-07 14:19:15.908976000 +0200
@@ -22,6 +22,8 @@
  * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *************************************************************************/
 
+/* #define PROFILING */
+
 #include "../include/config.h"
 #include "../include/common.h"
 #include "../include/objects.h"
@@ -32,6 +34,8 @@
 #include "../include/getcgi.h"
 #include "../include/cgiauth.h"
 
+#include "../xdata/xng.h"
+
 extern int             refresh_rate;
 extern time_t          program_start;
 
@@ -183,6 +187,7 @@
 	servicegroup *temp_servicegroup=NULL;
 	
 	time(&current_time);
+PROFILE(NULL);
 
 	/* get the arguments passed in the URL */
 	process_cgivars();
@@ -190,6 +195,8 @@
 	/* reset internal variables */
 	reset_cgi_vars();
 
+PROFILE("Before read_cgi_config_file");
+
 	/* read the CGI configuration file */
 	result=read_cgi_config_file(get_cgi_config_location());
 	if(result==ERROR){
@@ -199,6 +206,8 @@
 		return ERROR;
 	        }
 
+PROFILE("read_cgi_config_file");
+
 	/* read the main configuration file */
 	result=read_main_config_file(main_config_file);
 	if(result==ERROR){
@@ -208,6 +217,8 @@
 		return ERROR;
 	        }
 
+PROFILE("read_main_config_file");
+
 	/* read all object configuration data */
 	result=read_all_object_configuration_data(main_config_file,READ_ALL_OBJECT_DATA);
 	if(result==ERROR){
@@ -217,6 +228,8 @@
 		return ERROR;
                 }
 
+PROFILE("read_all_object_configuration_data");
+
 	/* read all status data */
 	result=read_all_status_data(get_cgi_config_location(),READ_ALL_STATUS_DATA);
 	if(result==ERROR){
@@ -227,6 +240,8 @@
 		return ERROR;
                 }
 
+PROFILE("read_all_status_data");
+
 	document_header(TRUE);
 
 	/* read in all host and service comments */
@@ -473,6 +488,7 @@
 	free_servicesort_list();
 	free_hostsort_list();
 
+PROFILE("End");
 	return OK;
         }
 
diff -Naur nagios-2.0b3/common/objects.c nagios-2.0b3-test/common/objects.c
--- nagios-2.0b3/common/objects.c	2004-11-30 18:16:23.000000000 +0100
+++ nagios-2.0b3-test/common/objects.c	2005-06-06 19:49:47.540536000 +0200
@@ -41,6 +41,12 @@
 #include "../xdata/xodtemplate.h"
 #endif
   
+#ifdef USE_XODNG
+extern int xodng_free_memory();
+extern int xodng_free_extended_data();
+#include "../xdata/xng.h"
+#endif
+  
 
 host            *host_list=NULL,*host_list_tail=NULL;
 service         *service_list=NULL,*service_list_tail=NULL;
@@ -89,12 +95,16 @@
 #endif
 
 	/********* IMPLEMENTATION-SPECIFIC INPUT FUNCTION ********/
+#if (defined(NSCGI)&&defined(USE_XODNG))
+result=xodng_read_config_data(main_config_file,options,cache);
+#else
 #ifdef USE_XODTEMPLATE
 	/* read in data from all text host config files (template-based) */
 	result=xodtemplate_read_config_data(main_config_file,options,cache);
 	if(result!=OK)
 		return ERROR;
 #endif
+#endif
 
 #ifdef DEBUG0
 	printf("read_object_config_data() end\n");
@@ -2405,8 +2415,8 @@
 #ifdef DEBUG1
 	printf("\tContact Name:                  %s\n",new_contact->name);
 	printf("\tContact Alias:                 %s\n",new_contact->alias);
-	printf("\tContact Email Address:         %s\n",new_contact->email);
-	printf("\tContact Pager Address/Number:  %s\n",new_contact->pager);
+	printf("\tContact Email Address:         %s\n",(new_contact->email ? new_contact->email : "<null>"));
+	printf("\tContact Pager Address/Number:  %s\n",(new_contact->pager ? new_contact->pager : "<null>"));
 	printf("\tSvc Notification Time Period:  %s\n",new_contact->service_notification_period);
 	printf("\tHost Notification Time Period: %s\n",new_contact->host_notification_period);
 #endif
@@ -5636,7 +5646,11 @@
 
 
 /* free all allocated memory for objects */
+
 int free_object_data(void){
+#if (defined(NSCGI) && defined(USE_XODNG))
+return xodng_free_memory();
+#else
 	timeperiod *this_timeperiod=NULL;
 	timeperiod *next_timeperiod=NULL;
 	timerange *this_timerange=NULL;
@@ -6035,11 +6049,15 @@
 #endif
 
 	return OK;
+#endif
         }
 
 
 /* free all allocated memory for extended info objects */
 int free_extended_data(void){
+#if (defined(NSCGI) && defined(USE_XODNG))
+return xodng_free_extended_data();
+#else
 	hostextinfo *this_hostextinfo=NULL;
 	hostextinfo *next_hostextinfo=NULL;
 	serviceextinfo *this_serviceextinfo=NULL;
@@ -6096,9 +6114,10 @@
 
 
 #ifdef DEBUG0
-	printf("free_extended_data() start\n");
+	printf("free_extended_data() end\n");
 #endif
 
 	return OK;
+#endif
         }
 
diff -Naur nagios-2.0b3/common/statusdata.c nagios-2.0b3-test/common/statusdata.c
--- nagios-2.0b3/common/statusdata.c	2004-10-25 07:05:56.000000000 +0200
+++ nagios-2.0b3-test/common/statusdata.c	2005-06-06 19:53:22.752000000 +0200
@@ -38,6 +38,13 @@
 #include "../include/cgiutils.h"
 #endif
 
+#ifdef NSCGI
+#ifdef USE_XSDNG
+#undef USE_XSDDEFAULT
+#undef USE_XSDDB
+#endif
+#endif
+
 /**** IMPLEMENTATION SPECIFIC HEADER FILES ****/
 
 #ifdef USE_XSDDEFAULT
@@ -46,6 +53,9 @@
 #ifdef USE_XSDDB
 #include "../xdata/xsddb.h"                     /* database routines */
 #endif
+#ifdef USE_XSDNG
+#include "../xdata/xng.h"
+#endif
 
 
 #ifdef NSCORE
@@ -81,6 +91,9 @@
 #ifdef USE_XSDDB
 	result=xsddb_initialize_status_data(config_file);
 #endif
+#ifdef USE_XSDNG
+	result=xsdng_initialize_status_data(config_file);
+#endif
 
 	return result;
         }
@@ -97,6 +110,9 @@
 #ifdef USE_XSDDB
 	result=xsddb_save_status_data();
 #endif
+#ifdef USE_XSDNG
+	result=xsdng_save_status_data();
+#endif
 
 	if(result!=OK)
 		return ERROR;
@@ -116,6 +132,9 @@
 #ifdef USE_XSDDB
 	result=xsddb_cleanup_status_data(config_file,delete_status_data);
 #endif
+#ifdef USE_XSDNG
+	result=xsdng_cleanup_status_data(config_file,delete_status_data);
+#endif
 
 	return result;
         }
@@ -201,6 +220,9 @@
 #ifdef USE_XSDDB
 	result=xsddb_read_status_data(config_file,options);
 #endif
+#ifdef USE_XSDNG
+	result=xsdng_read_status_data(config_file,options);
+#endif
 
 	return result;
         }
@@ -435,6 +457,9 @@
 
 /* free all memory for status data */
 void free_status_data(void){
+#ifdef USE_XSDNG
+xsdng_free_status_data();
+#else
 	hoststatus *this_hoststatus;
 	hoststatus *next_hoststatus;
 	servicestatus *this_svcstatus;
@@ -458,6 +483,7 @@
 		free(this_svcstatus->perf_data);
 		free(this_svcstatus);
 	        }
+#endif
 
 	/* free hash lists reset list pointers */
 	free(hoststatus_hashlist);
diff -Naur nagios-2.0b3/include/objects.h nagios-2.0b3-test/include/objects.h
--- nagios-2.0b3/include/objects.h	2004-11-06 06:44:13.000000000 +0100
+++ nagios-2.0b3-test/include/objects.h	2005-06-07 14:24:22.751257000 +0200
@@ -65,71 +65,77 @@
 
 /* TIMERANGE structure */
 typedef struct timerange_struct{
+	struct timerange_struct *next;
 	unsigned long range_start;
 	unsigned long range_end;
-	struct timerange_struct *next;
         }timerange;
 
 
 /* TIMEPERIOD structure */
 typedef struct timeperiod_struct{
-	char    *name;
-	char    *alias;
-	timerange *days[7];
 	struct 	timeperiod_struct *next;
 	struct 	timeperiod_struct *nexthash;
+	char *xng_tmp_offset;
+	timerange *days[7];
+	char    *name;
+	char    *alias;
 	}timeperiod;
 
 
 /* CONTACTGROUPMEMBER structure */
 typedef struct contactgroupmember_struct{
-	char    *contact_name;
 	struct  contactgroupmember_struct *next;
+	char    *contact_name;
         }contactgroupmember;
 
 
 /* CONTACTGROUP structure */
 typedef struct contactgroup_struct{
-	char	*group_name;
-	char    *alias;
-	contactgroupmember *members;
 	struct	contactgroup_struct *next;
 	struct	contactgroup_struct *nexthash;
+	char *xng_tmp_offset;
+	contactgroupmember *members;
+	char	*group_name;
+	char    *alias;
 	}contactgroup;
 
 
 /* CONTACTGROUPSMEMBER structure */
 typedef struct contactgroupsmember_struct{
-	char *group_name;
 	struct contactgroupsmember_struct *next;
+	char *group_name;
         }contactgroupsmember;
 
 
 /* HOSTSMEMBER structure */
 typedef struct hostsmember_struct{
-	char *host_name;
 	struct hostsmember_struct *next;
+	char *host_name;
         }hostsmember;
 
 
 /* HOST structure */
 typedef struct host_struct{
+	struct  host_struct *next;
+	struct  host_struct *nexthash;
+	char *xng_tmp_offset;
+    hostsmember *parent_hosts;
+	contactgroupsmember *contact_groups;
 	char    *name;
 	char	*alias;
 	char    *address;
-        hostsmember *parent_hosts;
 	char    *host_check_command;
+	char    *event_handler;
+	char	*notification_period;
+	char    *check_period;
+	char    *failure_prediction_options;
 	int     check_interval;
 	int     max_attempts;
-	char    *event_handler;
-	contactgroupsmember *contact_groups;
 	int     notification_interval;
 	int	notify_on_down;
 	int	notify_on_unreachable;
 	int     notify_on_recovery;
 	int     notify_on_flapping;
-	char	*notification_period;
-	char    *check_period;
 	int     flap_detection_enabled;
 	double  low_flap_threshold;
 	double  high_flap_threshold;
@@ -145,7 +151,6 @@
 	int     retain_status_information;
 	int     retain_nonstatus_information;
 	int     failure_prediction_enabled;
-	char    *failure_prediction_options;
 	int     obsess_over_host;
 #ifdef NSCORE
 	int     problem_has_been_acknowledged;
@@ -191,62 +196,67 @@
 	unsigned long total_service_check_interval;
 	unsigned long modified_attributes;
 #endif
-	struct  host_struct *next;
-	struct  host_struct *nexthash;
         }host;
 
 
 /* HOSTGROUPMEMBER structure */
 typedef struct hostgroupmember_struct{
-	char    *host_name;
 	struct  hostgroupmember_struct *next;
+	char    *host_name;
         }hostgroupmember;
 
 
 /* HOSTGROUP structure */
 typedef struct hostgroup_struct{
-	char 	*group_name;
-	char    *alias;
-	hostgroupmember *members;
 	struct	hostgroup_struct *next;
 	struct	hostgroup_struct *nexthash;
+	char *xng_tmp_offset;
+	hostgroupmember *members;
+	char 	*group_name;
+	char    *alias;
 	}hostgroup;
 
 
 /* SERVICEGROUPMEMBER structure */
 typedef struct servicegroupmember_struct{
+	struct  servicegroupmember_struct *next;
 	char    *host_name;
 	char    *service_description;
-	struct  servicegroupmember_struct *next;
         }servicegroupmember;
 
 
 /* SERVICEGROUP structure */
 typedef struct servicegroup_struct{
-	char 	*group_name;
-	char    *alias;
-	servicegroupmember *members;
 	struct	servicegroup_struct *next;
 	struct	servicegroup_struct *nexthash;
+	char *xng_tmp_offset;
+	servicegroupmember *members;
+	char 	*group_name;
+	char    *alias;
 	}servicegroup;
 
 
 /* COMMANDSMEMBER structure */
 typedef struct commandsmember_struct{
-	char	*command;
 	struct	commandsmember_struct *next;
+	char	*command;
 	}commandsmember;
 
 
 /* CONTACT structure */
 typedef struct contact_struct{
+	struct	contact_struct *next;
+	struct	contact_struct *nexthash;
+	char *xng_tmp_offset;
+	commandsmember *host_notification_commands;
+	commandsmember *service_notification_commands;	
 	char	*name;
 	char	*alias;
 	char	*email;
 	char	*pager;
 	char    *address[MAX_CONTACT_ADDRESSES];
-	commandsmember *host_notification_commands;
-	commandsmember *service_notification_commands;	
+	char	*host_notification_period;
+	char	*service_notification_period;
 	int     notify_on_service_unknown;
 	int     notify_on_service_warning;
 	int     notify_on_service_critical;
@@ -256,25 +266,27 @@
 	int	notify_on_host_unreachable;
 	int	notify_on_host_recovery;
 	int     notify_on_host_flapping;
-	char	*host_notification_period;
-	char	*service_notification_period;
-	struct	contact_struct *next;
-	struct	contact_struct *nexthash;
 	}contact;
 
 
 
 /* SERVICE structure */
 typedef struct service_struct{
+	struct service_struct *next;
+	struct service_struct *nexthash;
+	char *xng_tmp_offset;
+	contactgroupsmember *contact_groups;
 	char	*host_name;
 	char	*description;
-        char    *service_check_command;
+    char    *service_check_command;
 	char    *event_handler;
+	char	*notification_period;
+	char	*check_period;
+	char    *failure_prediction_options;
 	int	check_interval;
 	int     retry_interval;
 	int	max_attempts;
 	int     parallelize;
-	contactgroupsmember *contact_groups;
 	int	notification_interval;
 	int     notify_on_unknown;
 	int	notify_on_warning;
@@ -286,8 +298,6 @@
 	int     stalk_on_unknown;
 	int     stalk_on_critical;
 	int     is_volatile;
-	char	*notification_period;
-	char	*check_period;
 	int     flap_detection_enabled;
 	double  low_flap_threshold;
 	double  high_flap_threshold;
@@ -302,7 +312,6 @@
 	int     notifications_enabled;
 	int     obsess_over_service;
 	int     failure_prediction_enabled;
-	char    *failure_prediction_options;
 #ifdef NSCORE
 	int     problem_has_been_acknowledged;
 	int     acknowledgement_type;
@@ -350,45 +359,48 @@
 	double  percent_state_change;
 	unsigned long modified_attributes;
 #endif
-	struct service_struct *next;
-	struct service_struct *nexthash;
 	}service;
 
 
 /* COMMAND structure */
 typedef struct command_struct{
-	char    *name;
-	char    *command_line;
 	struct command_struct *next;
 	struct command_struct *nexthash;
+	char *xng_tmp_offset;
+	char    *name;
+	char    *command_line;
         }command;
 
 
 /* SERVICE ESCALATION structure */
 typedef struct serviceescalation_struct{
+	struct  serviceescalation_struct *next;
+	struct  serviceescalation_struct *nexthash;
+	char *xng_tmp_offset;
+	contactgroupsmember *contact_groups;
 	char    *host_name;
 	char    *description;
+	char    *escalation_period;
 	int     first_notification;
 	int     last_notification;
 	int     notification_interval;
-	char    *escalation_period;
 	int     escalate_on_recovery;
 	int     escalate_on_warning;
 	int     escalate_on_unknown;
 	int     escalate_on_critical;
-	contactgroupsmember *contact_groups;
-	struct  serviceescalation_struct *next;
-	struct  serviceescalation_struct *nexthash;
         }serviceescalation;
 
 
 /* SERVICE DEPENDENCY structure */
 typedef struct servicedependency_struct{
-	int     dependency_type;
+	struct servicedependency_struct *next;
+	struct servicedependency_struct *nexthash;
+	char *xng_tmp_offset;
 	char    *dependent_host_name;
 	char    *dependent_service_description;
 	char    *host_name;
 	char    *service_description;
+	int     dependency_type;
 	int     inherits_parent;
 	int     fail_on_ok;
 	int     fail_on_warning;
@@ -398,32 +410,34 @@
 #ifdef NSCORE
 	int     has_been_checked;
 #endif
-	struct servicedependency_struct *next;
-	struct servicedependency_struct *nexthash;
         }servicedependency;
 
 
 /* HOST ESCALATION structure */
 typedef struct hostescalation_struct{
+	struct  hostescalation_struct *next;
+	struct  hostescalation_struct *nexthash;
+	char *xng_tmp_offset;
+	contactgroupsmember *contact_groups;
 	char    *host_name;
+	char    *escalation_period;
 	int     first_notification;
 	int     last_notification;
 	int     notification_interval;
-	char    *escalation_period;
 	int     escalate_on_recovery;
 	int     escalate_on_down;
 	int     escalate_on_unreachable;
-	contactgroupsmember *contact_groups;
-	struct  hostescalation_struct *next;
-	struct  hostescalation_struct *nexthash;
         }hostescalation;
 
 
 /* HOST DEPENDENCY structure */
 typedef struct hostdependency_struct{
-	int     dependency_type;
+	struct hostdependency_struct *next;
+	struct hostdependency_struct *nexthash;
+	char *xng_tmp_offset;
 	char    *dependent_host_name;
 	char    *host_name;
+	int     dependency_type;
 	int     inherits_parent;
 	int     fail_on_up;
 	int     fail_on_down;
@@ -432,13 +446,14 @@
 #ifdef NSCORE
 	int     has_been_checked;
 #endif
-	struct hostdependency_struct *next;
-	struct hostdependency_struct *nexthash;
         }hostdependency;
 
 
 /* EXTENDED HOST INFO structure */
 typedef struct hostextinfo_struct{
+	struct hostextinfo_struct *next;
+	struct hostextinfo_struct *nexthash;
+	char *xng_tmp_offset;
 	char *host_name;
 	char *notes;
 	char *notes_url;
@@ -455,13 +470,14 @@
 	double y_3d;
 	double z_3d;
 	int should_be_drawn;
-	struct hostextinfo_struct *next;
-	struct hostextinfo_struct *nexthash;
         }hostextinfo;
 
 
 /* EXTENDED SERVICE INFO structure */
 typedef struct serviceextinfo_struct{
+	struct serviceextinfo_struct *next;
+	struct serviceextinfo_struct *nexthash;
+	char *xng_tmp_offset;
 	char *host_name;
 	char *description;
 	char *notes;
@@ -469,23 +485,10 @@
 	char *action_url;
 	char *icon_image;
 	char *icon_image_alt;
-	struct serviceextinfo_struct *next;
-	struct serviceextinfo_struct *nexthash;
         }serviceextinfo;
 
 
 
-/****************** HASH STRUCTURES ********************/
-
-typedef struct host_cursor_struct{
-	int     host_hashchain_iterator;
-	host    *current_host_pointer;
-        }host_cursor;
-
-
-
-
-
 /********************* FUNCTIONS **********************/
 
 /**** DEBUG functions ****/
@@ -626,6 +629,5 @@
 int free_object_data(void);                             /* frees all allocated memory for the object definitions */
 int free_extended_data(void);                           /* frees memory allocated to the extended host/service information */
 
-
 #endif
 
diff -Naur nagios-2.0b3/xdata/xng.h nagios-2.0b3-test/xdata/xng.h
--- nagios-2.0b3/xdata/xng.h	1970-01-01 01:00:00.000000000 +0100
+++ nagios-2.0b3-test/xdata/xng.h	2005-06-03 19:39:32.572305000 +0200
@@ -0,0 +1,69 @@
+
+#ifndef _XNG_H
+#define _XNG_H
+
+#include <time.h>
+#include <string.h>
+
+/*-----------------------*/
+
+#define XNG_VERSION	1
+
+typedef struct
+	{
+	time_t creation_time;
+	int version;
+	int nb_sections;
+	int string_section_offset;
+	} PREFIX_BLOCK;
+
+typedef struct
+	{
+	int type;
+	int offset;
+	int size;
+	char *data;
+	} SECTION_DESC;
+
+typedef int (*INT_FUNC)();
+
+#define PROGRAM_SECTION_TYPE		0
+#define HOSTSTATUS_SECTION_TYPE		1
+#define SERVICESTATUS_SECTION_TYPE	2
+#define OBJECTS_SECTION_TYPE		3
+
+typedef size_t	OFFSET;
+
+#define OFFSET_OF(struct,field)		&(((struct *)0)->field)
+
+#define COPY	memcpy
+
+#define XNG_RESTORE_POINTER(_p,_base)	(_p ? (_base + (OFFSET)_p) : NULL)
+
+#define XNG_ENCODE_POINTER(_p,_offset)	(p ? offset : NULL)
+
+#ifdef PROFILING
+extern void _profile(char *);
+#define PROFILE _profile
+#else
+#define PROFILE(_text)
+#endif
+
+/*-----------------------*/
+
+extern char *xng_allocate();
+extern int xng_list_count();
+extern void xng_string_init();
+extern char *xng_string_add();
+extern OFFSET xng_string_get();
+extern void xng_section_table_init();
+extern int xng_section_table_add();
+extern int xng_section_table_get();
+extern void xng_file_init();
+extern int xng_file_dump();
+extern int xng_file_get();
+extern int serialize_and_add_section();
+extern int unserialize_section();
+
+/*-----------------------*/
+#endif
diff -Naur nagios-2.0b3/xdata/xngutils.c nagios-2.0b3-test/xdata/xngutils.c
--- nagios-2.0b3/xdata/xngutils.c	1970-01-01 01:00:00.000000000 +0100
+++ nagios-2.0b3-test/xdata/xngutils.c	2005-06-03 19:43:00.997077000 +0200
@@ -0,0 +1,306 @@
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <time.h>
+#include <strings.h>
+
+#include "../include/common.h"
+
+#include "xng.h"
+
+/*---------------------*/
+
+void _profile(char *text)
+{
+static clock_t sclock,nclock;
+
+if (!text)
+	{
+	sclock=clock();
+	return;
+	}
+
+nclock=clock();
+fprintf(stderr,">>> %s: %ld ms\n",text,(nclock-sclock)*1000/CLOCKS_PER_SEC);
+sclock=nclock;
+}
+
+/*---------------------*/
+
+char *xng_allocate(char *p, int size)
+{
+if (p)
+	{
+	if (size) p=realloc(p,size);
+	else
+		{
+		free(p);
+		p=NULL;
+		}
+	}
+else p=(size ? malloc(size) : NULL);
+return p;
+}
+
+/*---------------------*/
+
+int xng_list_count(void *startp)
+{
+int count;
+void **p;
+
+count=0;
+if (startp) for (p=(void **)startp,count=0;p;p=(void **)(*p)) count++;
+return count;
+}
+
+/*---------------------*/
+
+#ifdef NSCORE
+
+static char *string_buffer=NULL;
+static OFFSET string_current_size=0;
+static OFFSET string_current_offset=0;
+
+#define INCREMENT	16*1024
+
+/*---------------------*/
+
+void xng_string_init()
+{
+string_buffer=xng_allocate(string_buffer
+	,string_current_size=string_current_offset=(OFFSET)0);
+}
+
+/*---------------------*/
+/* Renvoie l'offset de la chaine dans le buffer */
+
+char *xng_string_add(char *string)
+{
+OFFSET len,off,future_size;
+
+if (!string) return NULL;
+
+if (!string_buffer)	/* Nobody gets an offset = 0 */
+	{
+	string_buffer=xng_allocate(NULL,string_current_size=INCREMENT);
+	string_current_offset=1;
+	}
+
+future_size=string_current_offset+(len=strlen(string))+1;
+while(future_size > string_current_size)
+	string_buffer=xng_allocate(string_buffer,string_current_size+=INCREMENT);
+strcpy(string_buffer+string_current_offset,string);
+off=string_current_offset;
+string_current_offset += len+1;
+return (char *)off;
+}
+	
+/*---------------------*/
+/* Renvoie le buffer et sa taille */
+
+OFFSET xng_string_get(char **pp)
+{
+*pp=string_buffer;
+return string_current_offset;
+}
+
+#endif
+
+/*=====================================================*/
+
+#ifdef NSCORE
+
+static SECTION_DESC *section_table=NULL;
+static int section_table_size=0;
+
+/*---------------------*/
+
+void xng_section_table_init()
+{
+int i;
+
+if (section_table_size) for (i=0;i<section_table_size;i++)
+	xng_allocate(section_table[i].data,0);
+
+section_table=(SECTION_DESC *)xng_allocate((char *)section_table
+	,section_table_size=0);
+}
+
+/*---------------------*/
+/* Renvoie l'index du nouvel element dans la table */
+
+int xng_section_table_add(SECTION_DESC *sp)
+{
+int s;
+
+section_table=(SECTION_DESC *)xng_allocate((char *)section_table
+	,(section_table_size+1)*sizeof(SECTION_DESC));
+COPY((char *)(section_table+(s=section_table_size++)),(char *)sp,sizeof(SECTION_DESC));
+return s;
+}
+
+/*---------------------*/
+/* Renvoie le nombre d'elements dans la table et l'adresse */
+
+int xng_section_table_get(SECTION_DESC **spp)
+{
+*spp=section_table;
+return section_table_size;
+}
+
+/*=====================================================*/
+
+void xng_file_init()
+{
+xng_string_init();
+xng_section_table_init();
+}
+
+/*---------------------*/
+
+int xng_file_dump(char *filename)
+{
+FILE *fp;
+PREFIX_BLOCK pb;
+SECTION_DESC *stp;
+int nb_sections,i,offset,len;
+char *stringp;
+
+if (!(fp=fopen(filename,"w"))) return ERROR;
+
+pb.nb_sections=nb_sections=xng_section_table_get(&stp);
+pb.creation_time=time(NULL);
+pb.version=XNG_VERSION;
+
+for (i=0,offset=0;i<nb_sections;i++)
+	{
+	stp[i].offset = offset;
+	offset += stp[i].size;
+	}
+
+pb.string_section_offset=offset;
+
+(void)fwrite((void *)(&pb),sizeof(pb),1,fp); /* Write prefix */
+(void)fwrite((void *)stp,nb_sections*sizeof(*stp),1,fp); /* Write section table */
+
+/* Write sections */
+
+for(i=0;i<nb_sections;i++) (void)fwrite((void *)(stp[i].data),stp[i].size,1,fp);
+
+/* Write strings */
+
+len=xng_string_get(&stringp);
+(void)fwrite((void *)stringp,len,1,fp);
+
+fclose(fp);
+
+return OK;
+}
+
+#endif
+
+/*---------------------*/
+
+#ifdef NSCGI
+
+int xng_file_get(char *filename,char **bufp)
+{
+struct stat st;
+off_t len;
+char *basep,*strings,*datap;
+FILE *fp;
+PREFIX_BLOCK *pbp;
+SECTION_DESC *stp;
+int i;
+
+if (stat(filename,&st)) return ERROR;
+len=st.st_size;
+if (!(pbp=(PREFIX_BLOCK *)(basep=*bufp=xng_allocate(NULL,len)))) return ERROR;
+if (!(fp=fopen(filename,"r"))) return ERROR;
+if (!fread(basep,len,1,fp)) return ERROR;
+(void)fclose(fp);
+
+if (pbp->version != XNG_VERSION) return ERROR;
+if (! pbp->nb_sections) return OK;
+
+datap=basep+sizeof(PREFIX_BLOCK)+pbp->nb_sections*sizeof(SECTION_DESC);
+strings=datap+pbp->string_section_offset;
+
+for (i=0,stp=(SECTION_DESC *)(basep+sizeof(PREFIX_BLOCK))
+	;i<pbp->nb_sections;i++,stp++)
+	{
+	stp->data=datap+stp->offset;
+	if (unserialize_section(stp,strings)) return ERROR;
+	}
+
+return OK;
+}
+
+#endif
+
+/*=====================================================*/
+
+#ifdef NSCORE
+
+extern int serialize_program();
+extern int serialize_hoststatus();
+extern int serialize_servicestatus();
+
+int serialize_object_section(char **, int);
+
+static INT_FUNC section_serialize_funcs[OBJECTS_SECTION_TYPE]={
+	serialize_program,
+	serialize_hoststatus,
+	serialize_servicestatus
+	};
+
+int serialize_and_add_section(int section_type)
+{
+SECTION_DESC section;
+
+section.type=section_type;
+
+section.size=(section_type < OBJECTS_SECTION_TYPE) 
+	? (section_serialize_funcs[section_type])(&(section.data))
+	: serialize_object_section(&(section.data),section_type-OBJECTS_SECTION_TYPE);
+
+if (section.size==ERROR) return ERROR;
+
+xng_section_table_add(&section);
+
+return OK;
+}
+
+#endif
+
+/*=====================================================*/
+
+#ifdef NSCGI
+
+extern int unserialize_program();
+extern int unserialize_hoststatus();
+extern int unserialize_servicestatus();
+
+extern int unserialize_object_section(char *, char *, int);
+
+static INT_FUNC section_unserialize_funcs[OBJECTS_SECTION_TYPE]={
+	unserialize_program,
+	unserialize_hoststatus,
+	unserialize_servicestatus
+	};
+
+int unserialize_section(SECTION_DESC *sdp,char *strings)
+{
+if (sdp->type < OBJECTS_SECTION_TYPE)
+	return section_unserialize_funcs[sdp->type](sdp->data,sdp->size,strings);
+else
+	return unserialize_object_section(sdp->data,strings
+		,sdp->type-OBJECTS_SECTION_TYPE);
+}
+
+#endif
+
+/*=====================================================*/
diff -Naur nagios-2.0b3/xdata/xodng.c nagios-2.0b3-test/xdata/xodng.c
--- nagios-2.0b3/xdata/xodng.c	1970-01-01 01:00:00.000000000 +0100
+++ nagios-2.0b3-test/xdata/xodng.c	2005-06-06 11:55:43.976756000 +0200
@@ -0,0 +1,491 @@
+
+#include <time.h>
+
+#ifdef NSCORE
+#undef NSCORE
+#define NSCGI
+#include "../include/objects.h"
+#undef NSCGI
+#define NSCORE
+#else
+#include "../include/objects.h"
+#endif
+
+#include "../include/common.h"
+
+#include "xng.h"
+
+#define XODNG_DUMP_FILE "/usr/nagios/var/objects.cache.dmp"
+
+/*-------------------------*/
+
+extern command         **command_hashlist;
+extern contact         **contact_hashlist;
+extern contactgroup    **contactgroup_hashlist;
+extern host				**host_hashlist;
+extern hostdependency  **hostdependency_hashlist;
+extern hostescalation  **hostescalation_hashlist;
+extern hostextinfo     **hostextinfo_hashlist;
+extern hostgroup       **hostgroup_hashlist;
+extern service			**service_hashlist;
+extern servicedependency **servicedependency_hashlist;
+extern serviceescalation **serviceescalation_hashlist;
+extern serviceextinfo  **serviceextinfo_hashlist;
+extern servicegroup    **servicegroup_hashlist;
+extern timeperiod      **timeperiod_hashlist;
+
+extern command 		 *command_list;
+extern contact 		 *contact_list;
+extern contactgroup	 *contactgroup_list;
+extern host			 *host_list;
+extern hostdependency   *hostdependency_list;
+extern hostescalation   *hostescalation_list;
+extern hostextinfo 	 *hostextinfo_list;
+extern hostgroup		 *hostgroup_list;
+extern service 		 *service_list;
+extern servicedependency *servicedependency_list;
+extern serviceescalation *serviceescalation_list;
+extern serviceextinfo   *serviceextinfo_list;
+extern servicegroup	 *servicegroup_list;
+extern timeperiod  	 *timeperiod_list;
+
+/*-------------------------*/
+
+typedef struct
+	{
+	int size;
+	int nb_strings;
+	int nb; /* Not initialized */
+	OFFSET base_offset; /* Not initialized */
+	OFFSET write_offset; /* Not initialized */
+	} SUB_OBJECT_DESC;
+
+typedef struct {
+	char **object_list_address;
+	char **object_hashlist_address;
+	int hashslots;
+	int nb_sub_objects;
+	SUB_OBJECT_DESC *sub_objects;
+	} OBJECT_DESC;
+
+
+static SUB_OBJECT_DESC timeperiod_sub_objects[]={
+	  { sizeof(timeperiod), 2 }
+	, { sizeof(timerange), 0 }
+	, { sizeof(timerange), 0 }
+	, { sizeof(timerange), 0 }
+	, { sizeof(timerange), 0 }
+	, { sizeof(timerange), 0 }
+	, { sizeof(timerange), 0 }
+	, { sizeof(timerange), 0 } };
+
+static SUB_OBJECT_DESC contactgroup_sub_objects[]={
+	  { sizeof(contactgroup), 2 }
+	, { sizeof(contactgroupmember), 1 } };
+
+static SUB_OBJECT_DESC host_sub_objects[]={
+	  { sizeof(host), 8 }
+	, { sizeof(hostsmember), 1 }
+	, { sizeof(contactgroupsmember), 1 } };
+
+static SUB_OBJECT_DESC hostgroup_sub_objects[]={
+	  { sizeof(hostgroup), 2 }
+	, { sizeof(hostgroupmember), 1 } };
+
+static SUB_OBJECT_DESC servicegroup_sub_objects[]={
+	  { sizeof(servicegroup), 2 }
+	, { sizeof(servicegroupmember), 2 } };
+
+static SUB_OBJECT_DESC contact_sub_objects[]={
+	  { sizeof(contact), MAX_CONTACT_ADDRESSES+6 }
+	, { sizeof(commandsmember), 1 }
+	, { sizeof(commandsmember), 1 } };
+
+static SUB_OBJECT_DESC service_sub_objects[]={
+	  { sizeof(service), 7 }
+	, { sizeof(contactgroupsmember), 1 } };
+
+static SUB_OBJECT_DESC command_sub_objects[]={
+	  { sizeof(command), 2 } };
+
+static SUB_OBJECT_DESC serviceescalation_sub_objects[]={
+	  { sizeof(serviceescalation), 3 }
+	, { sizeof(contactgroupsmember), 1 } };
+
+static SUB_OBJECT_DESC servicedependency_sub_objects[]={
+	  { sizeof(servicedependency), 4 } };
+
+static SUB_OBJECT_DESC hostescalation_sub_objects[]={
+	  { sizeof(hostescalation), 2 }
+	, { sizeof(contactgroupsmember), 1 } };
+
+static SUB_OBJECT_DESC hostdependency_sub_objects[]={
+	  { sizeof(hostdependency), 2 } };
+
+static SUB_OBJECT_DESC hostextinfo_sub_objects[]={
+	  { sizeof(hostextinfo), 8 } };
+
+static SUB_OBJECT_DESC serviceextinfo_sub_objects[]={
+	  { sizeof(serviceextinfo), 7 } };
+
+
+#define NB_OBJECT_TYPES	14
+
+static OBJECT_DESC object_descriptors[NB_OBJECT_TYPES]={
+	{
+	(char **)(&timeperiod_list),
+	(char **)(&timeperiod_hashlist),
+	TIMEPERIOD_HASHSLOTS,
+	7,
+	timeperiod_sub_objects
+	},
+
+	{
+	(char **)(&contactgroup_list),
+	(char **)(&contactgroup_hashlist),
+	CONTACTGROUP_HASHSLOTS,
+	1,
+	contactgroup_sub_objects
+	},
+
+	{
+	(char **)(&host_list),
+	(char **)(&host_hashlist),
+	HOST_HASHSLOTS,
+	2,
+	host_sub_objects
+	},
+
+	{
+	(char **)(&hostgroup_list),
+	(char **)(&hostgroup_hashlist),
+	HOSTGROUP_HASHSLOTS,
+	1,
+	hostgroup_sub_objects
+	},
+
+	{
+	(char **)(&servicegroup_list),
+	(char **)(&servicegroup_hashlist),
+	SERVICEGROUP_HASHSLOTS,
+	2,
+	servicegroup_sub_objects
+	},
+
+	{
+	(char **)(&contact_list),
+	(char **)(&contact_hashlist),
+	CONTACT_HASHSLOTS,
+	2,
+	contact_sub_objects
+	},
+
+	{
+	(char **)(&service_list),
+	(char **)(&service_hashlist),
+	SERVICE_HASHSLOTS,
+	1,
+	service_sub_objects	
+	},
+
+	{
+	(char **)(&command_list),
+	(char **)(&command_hashlist),
+	COMMAND_HASHSLOTS,
+	0,
+	command_sub_objects
+	},
+
+	{
+	(char **)(&serviceescalation_list),
+	(char **)(&serviceescalation_hashlist),
+	SERVICEESCALATION_HASHSLOTS,
+	1,
+	serviceescalation_sub_objects
+	},
+
+	{
+	(char **)(&servicedependency_list),
+	(char **)(&servicedependency_hashlist),
+	SERVICEDEPENDENCY_HASHSLOTS,
+	0,
+	servicedependency_sub_objects
+	},
+
+	{
+	(char **)(&hostescalation_list),
+	(char **)(&hostescalation_hashlist),
+	HOSTESCALATION_HASHSLOTS,
+	1,
+	hostescalation_sub_objects
+	},
+
+	{
+	(char **)(&hostdependency_list),
+	(char **)(&hostdependency_hashlist),
+	HOSTDEPENDENCY_HASHSLOTS,
+	0,
+	hostdependency_sub_objects
+	},
+
+	{
+	(char **)(&hostextinfo_list),
+	(char **)(&hostextinfo_hashlist),
+	HOSTEXTINFO_HASHSLOTS,
+	0,
+	hostextinfo_sub_objects
+	},
+
+	{
+	(char **)(&serviceextinfo_list),
+	(char **)(&serviceextinfo_hashlist),
+	SERVICEEXTINFO_HASHSLOTS,
+	0,
+	serviceextinfo_sub_objects
+	}
+	};
+
+#ifdef NSCGI
+
+static char *xodng_last_read_buffer=NULL;
+
+/*-----------------------*/
+
+int xodng_read_config_data(char *main_config_file,int options,int cache)
+{
+return xng_file_get(XODNG_DUMP_FILE,&xodng_last_read_buffer);
+}
+
+/*-----------------------*/
+
+int xodng_free_memory(void)
+{
+xodng_last_read_buffer=xng_allocate(xodng_last_read_buffer,0);
+
+command_hashlist=(command **)(command_list=(command *)0);
+contact_hashlist=(contact **)(contact_list=(contact *)0);
+contactgroup_hashlist=(contactgroup **)(contactgroup_list=(contactgroup *)0);
+host_hashlist=(host **)(host_list=(host *)0);
+hostdependency_hashlist=(hostdependency **)(hostdependency_list=(hostdependency *)0);
+hostescalation_hashlist=(hostescalation **)(hostescalation_list=(hostescalation *)0);
+hostgroup_hashlist=(hostgroup **)(hostgroup_list=(hostgroup *)0);
+service_hashlist=(service **)(service_list=(service *)0);
+servicedependency_hashlist=(servicedependency **)(servicedependency_list=(servicedependency *)0);
+serviceescalation_hashlist=(serviceescalation **)(serviceescalation_list=(serviceescalation *)0);
+servicegroup_hashlist=(servicegroup **)(servicegroup_list=(servicegroup *)0);
+timeperiod_hashlist=(timeperiod **)(timeperiod_list=(timeperiod *)0);
+
+return OK;
+}
+
+/*-----------------------*/
+
+int xodng_free_extended_data(void)
+{
+xodng_last_read_buffer=xng_allocate(xodng_last_read_buffer,0);
+
+hostextinfo_hashlist=(hostextinfo **)(hostextinfo_list=(hostextinfo *)0);
+serviceextinfo_hashlist=(serviceextinfo **)(serviceextinfo_list=(serviceextinfo *)0);
+
+return OK;
+}
+
+/*-----------------------*/
+
+int unserialize_object_section(char *basep, char *strings, int otype)
+{
+int ssi,i,j,ss_nb; \
+char **pp,*ssp;
+SUB_OBJECT_DESC *sodesc;
+OBJECT_DESC *odesc;
+
+odesc=&(object_descriptors[otype]);
+
+*(odesc->object_list_address)=NULL;
+*(odesc->object_hashlist_address)=basep;
+
+for (i=0,pp=(char **)basep;i<odesc->hashslots;i++,pp++) /* Restore hash_list */
+	*pp=XNG_RESTORE_POINTER(*pp,basep);
+
+ssp=basep+odesc->hashslots*sizeof(char *);
+
+for (ssi=0,sodesc=odesc->sub_objects;ssi<(odesc->nb_sub_objects+1)
+	;ssi++,sodesc++)
+	{
+	ss_nb=*(int *)ssp;
+	ssp += sizeof(int);
+	if (ss_nb)
+		{
+		if (ssi==0) *(odesc->object_list_address)=ssp;
+		for (i=0,pp=(char **)ssp;i<ss_nb
+			;i++,pp=(char **)(ssp+=sodesc->size))
+			{
+			(*pp)=XNG_RESTORE_POINTER(*pp,basep); /* next */
+			pp++;
+			if (ssi==0)
+				{
+				(*pp)=XNG_RESTORE_POINTER(*pp,basep); /* nexthash */
+				pp+=2; /* xng_tmp_offset */
+				if (odesc->nb_sub_objects)
+					{
+					for (j=0;j<odesc->nb_sub_objects;j++)
+						{
+						(*pp)=XNG_RESTORE_POINTER(*pp,basep);
+						pp++;
+						}
+					}
+				}
+			if (sodesc->nb_strings)
+				{
+				for (j=0;j<sodesc->nb_strings;j++)
+					{
+					(*pp)=XNG_RESTORE_POINTER(*pp,strings);
+					pp++;
+					}
+				}
+			}
+		}
+	}
+
+return OK;
+}
+
+#endif
+
+/*-----------------------*/
+
+#ifdef NSCORE
+
+/*-----------------------*/
+
+int xodng_cache_objects(char *xodtemplate_cache_file)
+{	/* We will use the filename later... */
+int i,status;
+
+xng_file_init();
+
+for (i=0;i<NB_OBJECT_TYPES;i++)
+	if (serialize_and_add_section(OBJECTS_SECTION_TYPE+i)) return ERROR;
+
+status=xng_file_dump(XODNG_DUMP_FILE);
+xng_file_init();	/* Cleanup */
+return status;
+}
+
+/*-----------------------*/
+
+int serialize_object_section(char **basepp, int otype)
+{
+int size,hashsize,i,ssi,j,first;
+char **pp,**objpp,**pp2,**pp3,*basep,*sourcep;
+SUB_OBJECT_DESC *sodesc,*psodesc;
+OBJECT_DESC *odesc;
+
+odesc=&(object_descriptors[otype]);
+
+psodesc=&(odesc->sub_objects[0]);
+
+/* Compute size and offset of each subsection */
+
+size=(hashsize=odesc->hashslots*sizeof(char *))
+	+(odesc->nb_sub_objects+1)*sizeof(int);
+
+if (!(*(odesc->object_list_address))) /* Special case: Empty list */
+	{
+	(*basepp)=xng_allocate(NULL,size);
+	memset(*basepp,0,size);
+	return size;
+	}
+
+for (ssi=0,sodesc=odesc->sub_objects;ssi<(odesc->nb_sub_objects+1)
+		;ssi++,sodesc++) sodesc->nb=0;
+
+for (i=0,objpp=(char **)(*(odesc->object_list_address));objpp
+	;objpp=(char **)(*objpp),i++)
+	{
+	/* xng_tmp_offset */
+	(*(objpp+2))=(char *)(hashsize+sizeof(int)+i*psodesc->size);
+	pp=objpp+3; /* Pass next, nexthash, xng_tmp_offset */
+	for (ssi=0,sodesc=odesc->sub_objects;ssi<(odesc->nb_sub_objects+1)
+		;ssi++,sodesc++)
+		{
+		sodesc->nb+=(ssi ? xng_list_count(*(pp++)) : 1);
+		}
+	}
+
+for (ssi=0,sodesc=odesc->sub_objects,size=hashsize;ssi<(odesc->nb_sub_objects+1)
+		;ssi++,sodesc++)
+		{
+		sodesc->base_offset=(OFFSET)size;
+		sodesc->write_offset=(OFFSET)(size+sizeof(int));
+		size += sizeof(int)+sodesc->nb*sodesc->size;
+		}
+
+basep=(*basepp)=xng_allocate(NULL,size);
+
+/* Translate hash table */
+
+COPY(basep,*(odesc->object_hashlist_address),odesc->hashslots*sizeof(char *));
+for (i=0,pp=(char **)basep;i<odesc->hashslots;i++,pp++)
+	if (*pp) (*pp)=*((char **)((*pp)+2*sizeof(char *))); /* xng_tmp_offset */
+
+/* Write down subsection sizes (nb) */
+
+for (ssi=0,sodesc=odesc->sub_objects;ssi<(odesc->nb_sub_objects+1)
+		;ssi++,sodesc++) *(int *)(basep+sodesc->base_offset)=sodesc->nb;
+
+for (i=0,sourcep=*(odesc->object_list_address);i<psodesc->nb
+	;i++,sourcep=*(char **)sourcep)
+	{
+	COPY(pp=(char **)(basep+psodesc->write_offset),sourcep
+		,psodesc->size);
+	psodesc->write_offset += psodesc->size;
+	if (*pp) (*pp)=(char *)(psodesc->write_offset); /* Next */
+	pp++;
+	if (*pp) (*pp)=*((char **)((*pp)+2*sizeof(char *))); /* nexthash */
+	pp+=2;
+	if (odesc->nb_sub_objects)
+		{
+		for (ssi=1,sodesc=&(odesc->sub_objects[1]);ssi<odesc->nb_sub_objects+1
+			;ssi++,sodesc++,pp++)
+			{
+			if (!(pp2=(char **)(*pp))) continue;
+			first=1;
+			while (pp2)
+				{
+				pp3=(char **)(basep+sodesc->write_offset);
+				if (first)
+					{
+					(*pp)=(char *)(sodesc->write_offset); /* Link to 1st s/obj */
+					first=0;
+					}
+				COPY((char *)pp3,(char *)pp2,sodesc->size);
+				sodesc->write_offset += sodesc->size;
+				if (*pp3) (*pp3)=(char *)sodesc->write_offset; /* next */
+				if (sodesc->nb_strings)
+					{
+					for (j=0;j<sodesc->nb_strings;j++)
+						{
+						pp3++;
+						(*pp3)=xng_string_add(*pp3);
+						}
+					}
+				pp2=*(char ***)pp2;
+				}
+			}
+		}
+	if (psodesc->nb_strings)
+		{
+		for (j=0;j<psodesc->nb_strings;j++)
+			{
+			(*pp)=xng_string_add(*pp);
+			pp++;
+			}
+		}
+	}
+return size;
+}
+
+/*-----------------------*/
+
+#endif
diff -Naur nagios-2.0b3/xdata/xodtemplate.c nagios-2.0b3-test/xdata/xodtemplate.c
--- nagios-2.0b3/xdata/xodtemplate.c	2005-03-25 00:45:12.000000000 +0100
+++ nagios-2.0b3-test/xdata/xodtemplate.c	2005-06-06 20:10:06.792064000 +0200
@@ -268,6 +268,10 @@
 	/* cleanup */
 	xodtemplate_free_memory();
 
+#if (defined(NSCORE) && defined(USE_XODNG))
+	if (cache) xodng_cache_objects(xodtemplate_cache_file);
+#endif
+
 #ifdef DEBUG0
 	printf("xodtemplate_read_config_data() end\n");
 #endif
@@ -1568,11 +1572,11 @@
 	char temp_buffer[MAX_XODTEMPLATE_INPUT_BUFFER];
 #endif
 
+
 #ifdef DEBUG0
 	printf("xodtemplate_add_object_property() start\n");
 #endif
 
-
 	/* check to see if we should process this type of object */
 	switch(xodtemplate_current_object_type){
 	case XODTEMPLATE_TIMEPERIOD:
diff -Naur nagios-2.0b3/xdata/xodtemplate.h nagios-2.0b3-test/xdata/xodtemplate.h
--- nagios-2.0b3/xdata/xodtemplate.h	2004-10-25 07:05:57.000000000 +0200
+++ nagios-2.0b3-test/xdata/xodtemplate.h	2005-05-23 16:14:29.000000000 +0200
@@ -31,7 +31,7 @@
 
 /*********** GENERAL DEFINITIONS ************/
 
-#define MAX_XODTEMPLATE_INPUT_BUFFER    65535
+#define MAX_XODTEMPLATE_INPUT_BUFFER    65535*16
 
 #define MAX_XODTEMPLATE_CONTACT_ADDRESSES 6
 
diff -Naur nagios-2.0b3/xdata/xsdng.c nagios-2.0b3-test/xdata/xsdng.c
--- nagios-2.0b3/xdata/xsdng.c	1970-01-01 01:00:00.000000000 +0100
+++ nagios-2.0b3-test/xdata/xsdng.c	2005-06-06 15:05:27.857358000 +0200
@@ -0,0 +1,413 @@
+
+#include <time.h>
+
+#ifdef NSCORE
+#define NSCGI
+#include "../include/statusdata.h"
+#undef NSCGI
+#else
+#include "../include/statusdata.h"
+#endif
+
+#include "../include/common.h"
+
+#include "xng.h"
+
+#define XSDNG_DUMP_FILE "/usr/nagios/var/status.dat.dmp"
+
+#ifdef NSCGI
+time_t program_start;
+int daemon_mode;
+time_t last_command_check;
+time_t last_log_rotation;
+int enable_notifications;
+int execute_service_checks;
+int accept_passive_service_checks;
+int execute_host_checks;
+int accept_passive_host_checks;
+int enable_event_handlers;
+int obsess_over_services;
+int obsess_over_hosts;
+int check_service_freshness;
+int check_host_freshness;
+int enable_flap_detection;
+int enable_failure_prediction;
+int process_performance_data;
+int nagios_pid;
+#endif
+
+#ifdef NSCORE
+extern time_t program_start;
+extern int nagios_pid;
+extern int daemon_mode;
+extern time_t last_command_check;
+extern time_t last_log_rotation;
+extern int enable_notifications;
+extern int execute_service_checks;
+extern int accept_passive_service_checks;
+extern int execute_host_checks;
+extern int accept_passive_host_checks;
+extern int enable_event_handlers;
+extern int obsess_over_services;
+extern int obsess_over_hosts;
+extern int check_service_freshness;
+extern int check_host_freshness;
+extern int enable_flap_detection;
+extern int enable_failure_prediction;
+extern int process_performance_data;
+extern int aggregate_status_updates;
+
+extern host *host_list;
+extern service *service_list;
+
+extern unsigned long  modified_host_process_attributes;
+extern unsigned long  modified_service_process_attributes;
+extern char           *global_host_event_handler;
+extern char           *global_service_event_handler;
+#endif
+
+
+typedef struct {
+	unsigned long modified_host_process_attributes;
+	unsigned long modified_service_process_attributes;
+	int nagios_pid;
+	int daemon_mode;
+	time_t program_start;
+	time_t last_command_check;
+	time_t last_log_rotation;
+	int enable_notifications;
+	int execute_service_checks;
+	int accept_passive_service_checks;
+	int execute_host_checks;
+	int accept_passive_host_checks;
+	int enable_event_handlers;
+	int obsess_over_services;
+	int obsess_over_hosts;
+	int check_host_freshness;
+	int check_service_freshness;
+	int enable_flap_detection;
+	int enable_failure_prediction;
+	int process_performance_data;
+	char *global_host_event_handler;
+	char *global_service_event_handler;
+	} PROGRAM_STATUS;
+
+#ifdef NSCORE
+
+/*----------*/
+
+int xsdng_initialize_status_data(char *config_file)
+{
+/* (void)unlink(XSDNG_DUMP_FILE); */
+return OK;
+}
+
+/*----------*/
+
+int xsdng_cleanup_status_data(char *config_file, int delete_status_data)
+{
+if(delete_status_data)	/* delete the status log */
+	{
+	if(unlink(XSDNG_DUMP_FILE)) return ERROR;
+	}
+return OK;
+}
+
+/*----------*/
+
+int xsdng_save_status_data(void)
+{
+int status;
+
+xng_file_init();
+
+if (serialize_and_add_section(PROGRAM_SECTION_TYPE)) return ERROR;
+if (serialize_and_add_section(HOSTSTATUS_SECTION_TYPE)) return ERROR;
+if (serialize_and_add_section(SERVICESTATUS_SECTION_TYPE)) return ERROR;
+
+status=xng_file_dump(XSDNG_DUMP_FILE);
+xng_file_init();
+return status;
+}
+
+/*----------*/
+
+int serialize_program(char **p)
+{
+PROGRAM_STATUS *tp;
+
+tp=(PROGRAM_STATUS *)(*p=xng_allocate(NULL,sizeof(PROGRAM_STATUS)));
+
+tp->modified_host_process_attributes=modified_host_process_attributes;
+tp->modified_service_process_attributes=modified_service_process_attributes;
+tp->nagios_pid=nagios_pid;
+tp->daemon_mode=daemon_mode;
+tp->program_start=program_start;
+tp->last_command_check=last_command_check;
+tp->last_log_rotation=last_log_rotation;
+tp->enable_notifications=enable_notifications;
+tp->execute_service_checks=execute_service_checks;
+tp->accept_passive_service_checks=accept_passive_service_checks;
+tp->execute_host_checks=execute_host_checks;
+tp->accept_passive_host_checks=accept_passive_host_checks;
+tp->enable_event_handlers=enable_event_handlers;
+tp->obsess_over_services=obsess_over_services;
+tp->obsess_over_hosts=obsess_over_hosts;
+tp->check_host_freshness=check_host_freshness;
+tp->check_service_freshness=check_service_freshness;
+tp->enable_flap_detection=enable_flap_detection;
+tp->enable_failure_prediction=enable_failure_prediction;
+tp->process_performance_data=process_performance_data;
+tp->global_host_event_handler=xng_string_add(global_host_event_handler);
+tp->global_service_event_handler=xng_string_add(global_service_event_handler);
+
+return sizeof(PROGRAM_STATUS);
+}
+
+/*----------*/
+
+int serialize_hoststatus(char **p)
+{
+host *temp_host;
+int host_nb,bsize;
+hoststatus *thsp;
+char *basep;
+time_t last_update;
+
+last_update=time(NULL);
+
+if (host_list)
+	for(temp_host=host_list,host_nb=0;temp_host;temp_host=temp_host->next)
+		host_nb++;
+else host_nb=0;
+
+*p=basep=xng_allocate(NULL,bsize=host_nb*sizeof(hoststatus));
+if (!host_nb) return 0;
+
+for(temp_host=host_list,thsp=(hoststatus *)basep;temp_host
+	;temp_host=temp_host->next,thsp++)
+	{
+	thsp->last_update=last_update;
+	thsp->host_name=xng_string_add(temp_host->name);
+	thsp->plugin_output=xng_string_add(temp_host->plugin_output);
+	thsp->perf_data=xng_string_add(temp_host->perf_data);
+	thsp->execution_time=(double)temp_host->execution_time;
+	thsp->latency=(double)temp_host->latency;
+	thsp->has_been_checked=temp_host->has_been_checked;
+	thsp->should_be_scheduled=temp_host->should_be_scheduled;
+	thsp->status=temp_host->current_state;
+	thsp->last_hard_state=temp_host->last_hard_state;
+	thsp->current_attempt=temp_host->current_attempt;
+	thsp->max_attempts=temp_host->max_attempts;
+	thsp->last_check=temp_host->last_check;
+	thsp->next_check=temp_host->next_check;
+	thsp->check_type=temp_host->check_type;
+	thsp->current_attempt=temp_host->current_attempt;
+	thsp->state_type=temp_host->state_type;
+	thsp->last_state_change=temp_host->last_state_change;
+	thsp->last_hard_state_change=temp_host->last_hard_state_change;
+	thsp->last_time_up=temp_host->last_time_up;
+	thsp->last_time_down=temp_host->last_time_down;
+	thsp->last_time_unreachable=temp_host->last_time_unreachable;
+	thsp->last_notification=temp_host->last_host_notification;
+	thsp->next_notification=temp_host->next_host_notification;
+	thsp->no_more_notifications=temp_host->no_more_notifications;
+	thsp->current_notification_number=temp_host->current_notification_number;
+	thsp->notifications_enabled=temp_host->notifications_enabled;
+	thsp->problem_has_been_acknowledged=temp_host->problem_has_been_acknowledged;
+	thsp->acknowledgement_type=temp_host->acknowledgement_type;
+	thsp->checks_enabled=temp_host->checks_enabled;
+	thsp->accept_passive_host_checks=temp_host->accept_passive_host_checks;
+	thsp->event_handler_enabled=temp_host->event_handler_enabled;
+	thsp->flap_detection_enabled=temp_host->flap_detection_enabled;
+	thsp->failure_prediction_enabled=temp_host->failure_prediction_enabled;
+	thsp->process_performance_data=temp_host->process_performance_data;
+	thsp->obsess_over_host=temp_host->obsess_over_host;
+	thsp->is_flapping=temp_host->is_flapping;
+	thsp->percent_state_change=temp_host->percent_state_change;
+	thsp->scheduled_downtime_depth=temp_host->scheduled_downtime_depth;
+	}
+return bsize;
+}
+
+/*------------*/
+
+int serialize_servicestatus(char **p)
+{
+service *temp_service;
+int service_nb,bsize;
+servicestatus *tssp;
+char *basep;
+time_t last_update;
+
+last_update=time(NULL);
+
+if (service_list)
+	for(temp_service=service_list,service_nb=0;temp_service
+		;temp_service=temp_service->next)
+		service_nb++;
+else service_nb=0;
+
+*p=basep=xng_allocate(NULL,bsize=service_nb*sizeof(servicestatus));
+if (!service_nb) return 0;
+
+for(temp_service=service_list,tssp=(servicestatus *)basep;temp_service
+	;temp_service=temp_service->next,tssp++)
+	{
+	tssp->last_update=last_update;
+	tssp->host_name=xng_string_add(temp_service->host_name);
+	tssp->plugin_output=xng_string_add(temp_service->plugin_output);
+	tssp->perf_data=xng_string_add(temp_service->perf_data);
+	tssp->description=xng_string_add(temp_service->description);
+	tssp->execution_time=(double)temp_service->execution_time;
+	tssp->latency=(double)temp_service->latency;
+	tssp->status=temp_service->current_state;
+	tssp->has_been_checked=temp_service->has_been_checked	;
+	tssp->should_be_scheduled=temp_service->should_be_scheduled;
+	tssp->last_hard_state=temp_service->last_hard_state;
+	tssp->current_attempt=temp_service->current_attempt;
+	tssp->max_attempts=temp_service->max_attempts;
+	tssp->state_type=temp_service->state_type;
+	tssp->last_state_change=temp_service->last_state_change;
+	tssp->last_hard_state_change=temp_service->last_hard_state_change;
+	tssp->last_time_ok=temp_service->last_time_ok;
+	tssp->last_time_warning=temp_service->last_time_warning;
+	tssp->last_time_unknown=temp_service->last_time_unknown;
+	tssp->last_time_critical=temp_service->last_time_critical;
+	tssp->last_check=temp_service->last_check;
+	tssp->next_check=temp_service->next_check;
+	tssp->check_type=temp_service->check_type;
+	tssp->current_notification_number=temp_service->current_notification_number;
+	tssp->last_notification=temp_service->last_notification;
+	tssp->next_notification=temp_service->next_notification;
+	tssp->no_more_notifications=temp_service->no_more_notifications;
+	tssp->notifications_enabled=temp_service->notifications_enabled;
+	tssp->checks_enabled=temp_service->checks_enabled;
+	tssp->accept_passive_service_checks=temp_service->accept_passive_service_checks;
+	tssp->event_handler_enabled=temp_service->event_handler_enabled;
+	tssp->problem_has_been_acknowledged=temp_service->problem_has_been_acknowledged;
+	tssp->acknowledgement_type=temp_service->acknowledgement_type;
+	tssp->flap_detection_enabled=temp_service->flap_detection_enabled;
+	tssp->failure_prediction_enabled=temp_service->failure_prediction_enabled;
+	tssp->process_performance_data=temp_service->process_performance_data;
+	tssp->obsess_over_service=temp_service->obsess_over_service;
+	tssp->is_flapping=temp_service->is_flapping;
+	tssp->percent_state_change=temp_service->percent_state_change;
+	tssp->scheduled_downtime_depth=temp_service->scheduled_downtime_depth;
+	}
+
+return bsize;
+}
+
+#endif	/* NSCORE */
+
+/*----------*/
+
+#ifdef NSCGI
+
+static char *xsdng_last_read_buffer=NULL;
+
+/*----------*/
+
+void xsdng_free_status_data()
+{
+xsdng_last_read_buffer=xng_allocate(xsdng_last_read_buffer,0);
+}
+
+/*----------*/
+
+int xsdng_read_status_data(char *config_file,int options)
+{
+return xng_file_get(XSDNG_DUMP_FILE,&xsdng_last_read_buffer);
+}
+
+/*----------*/
+
+int unserialize_program(char *basep,int size,char *strings)
+{
+PROGRAM_STATUS *tp;
+
+tp=(PROGRAM_STATUS *)basep;
+
+nagios_pid=tp->nagios_pid;
+daemon_mode=tp->daemon_mode;
+program_start=tp->program_start;
+last_command_check=tp->last_command_check;
+last_log_rotation=tp->last_log_rotation;
+enable_notifications=tp->enable_notifications;
+execute_service_checks=tp->execute_service_checks;
+accept_passive_service_checks=tp->accept_passive_service_checks;
+execute_host_checks=tp->execute_host_checks;
+accept_passive_host_checks=tp->accept_passive_host_checks;
+enable_event_handlers=tp->enable_event_handlers;
+obsess_over_services=tp->obsess_over_services;
+obsess_over_hosts=tp->obsess_over_hosts;
+check_host_freshness=tp->check_host_freshness;
+check_service_freshness=tp->check_service_freshness;
+enable_flap_detection=tp->enable_flap_detection;
+enable_failure_prediction=tp->enable_failure_prediction;
+process_performance_data=tp->process_performance_data;
+
+return OK;
+}
+
+/*----------*/
+
+int unserialize_hoststatus(char *basep,int size,char *strings)
+{
+int i,host_nb;
+hoststatus *thsp;
+
+if (!size) return OK;
+
+host_nb=size/sizeof(hoststatus);
+
+for (i=0,thsp=(hoststatus *)basep;i<host_nb;i++,thsp++)
+	{
+	thsp->host_name=XNG_RESTORE_POINTER(thsp->host_name,strings);
+	thsp->plugin_output=XNG_RESTORE_POINTER(thsp->plugin_output,strings);
+	thsp->perf_data=XNG_RESTORE_POINTER(thsp->perf_data,strings);
+
+	if (!thsp->has_been_checked) /* just to allow add_host_status to free() it */
+		{
+		thsp->plugin_output=xng_allocate(NULL,1);
+		thsp->plugin_output[0]='\0';
+		}
+	if (add_host_status(thsp)) return ERROR;
+	}
+return OK;
+}
+
+/*----------*/
+
+int unserialize_servicestatus(char *basep,int size,char *strings)
+{
+int i,service_nb;
+servicestatus *tssp;
+
+if (!size) return OK;
+
+service_nb=size/sizeof(servicestatus);
+
+for (i=0,tssp=(servicestatus *)basep;i<service_nb;i++,tssp++)
+	{
+	tssp->host_name=XNG_RESTORE_POINTER(tssp->host_name,strings);
+	tssp->plugin_output=XNG_RESTORE_POINTER(tssp->plugin_output,strings);
+	tssp->perf_data=XNG_RESTORE_POINTER(tssp->perf_data,strings);
+	tssp->description=XNG_RESTORE_POINTER(tssp->description,strings);
+
+	if (!tssp->has_been_checked) /* just to allow add_service_status to free() it */
+		{
+		tssp->plugin_output=xng_allocate(NULL,1);
+		tssp->plugin_output[0]='\0';
+		}
+	if (add_service_status(tssp)) return ERROR;
+	}
+return OK;
+}
+
+/*----------*/
+
+#endif
+
+/*----------*/
